library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity data_transfer is

port (
	clk50: in std_logic;
	
	-- Avalon Bus Signals
    signal address : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
    signal chipselect : IN STD_LOGIC;
    signal read : IN STD_LOGIC;
    signal reset_n : IN STD_LOGIC;
    signal write : IN STD_LOGIC;
    signal writedata : IN unsigned (31 DOWNTO 0);
    signal readdata : OUT unsigned (31 DOWNTO 0);	

	h		: out std_logic;
	ch 	    : out unsigned(11 downto 0);
	cv      : out unsigned(11 downto 0);
	r       : out unsigned(5 downto 0)
);
end data_transfer;

architecture rtl of data_transfer is
		signal hit : std_logic;
		signal circleH : unsigned(11 downto 0);
		signal circleV : unsigned(11 downto 0);
		signal radius  : unsigned(5 downto 0);
		
		
	begin
		SetPixel	:	process(clk50)
		begin
			if rising_edge(clk50) then
				if chipselect = '1' then
					if write = '1' then
						hit <= writedata(30);
						circleH <= writedata(23 downto 12);
						circleV <= writedata(11 downto 0);
						radius <= writedata(29 downto 24);
				elsif read = '1' then

				end if;
			end if;
			end if;
		end process SetPixel;
		
		ch <= circleH;
		cv <= circleV;
		r  <= radius;
		h  <= hit;
end rtl;
			